'use strict';
const Alexa = require('alexa-sdk');

// FILL IN YOUR ENVIRONMENT VALUES HERE //
const APP_ID = '';
const hostName = '';
const accountName = 'AskFileMaker';
const accountPassword = 'apipassword';
//////////////////////////////////////////

const SKILL_NAME = 'AskFileMaker';
const HELP_MESSAGE = 'I cant help you.';
const HELP_REPROMPT = '';
const STOP_MESSAGE = 'Goodbye!';
const FAIL_MESSAGE = 'Im sorry, I dont understand the request.';
const ERROR_MESSAGE = 'Im sorry, there appears to be an error';

const handlers = {
    'LaunchRequest': function () {
        
        this.response.cardRenderer(SKILL_NAME, HELP_REPROMPT);
        this.response.speak(HELP_REPROMPT);
        this.emit(':responseReady');
        
    },
    'IntentRequest': function () {
        
        this.emit('AskFileMaker');
        
    },
    'AskFileMaker': function () {
        
        const thisIntent = this;
        
        // ACTION //
        const spokenAction = 
            "value" in this.event.request.intent.slots.action ? this.event.request.intent.slots.action.value :
            'find';
        
        const apiOption = 
            spokenAction==='add' ? 'record' :
            spokenAction==='delete' ? 'record' :
            spokenAction==='remove' ? 'record' :
            'find';
        
        // TABLE NAME //
        const spokenTable = this.event.request.intent.slots.table.value;
        
        const table = 
            spokenTable==='appointment' ? 'appointments' :
            spokenTable==='contact' ? 'people' :
            spokenTable==='contacts' ? 'people' :
            spokenTable==='person' ? 'people' :
            spokenTable;

        // FIELD NAME //
        const spokenField = 
            "value" in this.event.request.intent.slots.field ? this.event.request.intent.slots.field.value :
            'date';
            
        // CORRECTION FOR DIFFERENT SPOKEN FIELD EXPRESSIONS //
        const field =
            spokenField==='name' ? 'first' :
            spokenField==='first name' ? 'first' :
            spokenField==='1st name' ? 'first' :
            spokenField==='last name' ? 'last' :
            spokenField==='surname' ? 'last' :
            spokenField==='given name' ? 'first' :
            spokenField==='birthdays' ? 'birthday' :
            spokenField==='date of birth' ? 'birthday' :
            spokenField==='town' ? 'city' :
            spokenField;
         
        // A DATE VALUE //   
        const spokenDate = 
            "value" in this.event.request.intent.slots.date ? this.event.request.intent.slots.date.value :
            '';
        
        // CORRECTION FOR SPOKEN DATE //
        const date = 
            spokenDate==='' ? '' :
            spokenDate.substring(5, 10);
        
        // CONTENT VALUE //
        const content = 
            field==='date' && spokenAction==='add' ? date.replace('-', '/') :
            field==='date' && spokenAction==='find' ? date + '-*' : 
            field==='birthday' ? date + '-*' : 
            "value" in this.event.request.intent.slots.names ? this.event.request.intent.slots.names.value :
            "value" in this.event.request.intent.slots.value_state ? this.event.request.intent.slots.value_state.value :
            "value" in this.event.request.intent.slots.value_city ? this.event.request.intent.slots.value_city.value :
            '';
        
        // API START //
        var http = require("https");

        // auth POST //
        var options = {
            "method": "POST",
            "hostname": hostName,
            "port": "443",
            "path": "/fmi/rest/api/auth/People",
            "headers": {
                "content-type": "application/json",
                "cache-control": "no-cache"
            }
        };  

        var req = http.request(options, function (res) {
        var chunks = [];

            res.on("data", function (chunk) {
            chunks.push(chunk);
            });

            res.on ("error", function (e) {
            //callback (e);
            });

            res.on("end", function () {
                var body = Buffer.concat(chunks).toString();
                var ParsedBody = JSON.parse(body);
                var Token = ParsedBody.token;
    
                console.log(body.toString());
    
            // nested Action POST //
                var options_2 = {
                    "method": "POST",
                    "hostname": hostName,
                    "port": "443",
                    "path": "/fmi/rest/api/" + apiOption + "/People/" + table,
                    "headers": {
                    "content-type": "application/json",
                    "FM-Data-token": Token,
                    "cache-control": "no-cache"
                 }
                };

                var req_2 = http.request(options_2, function (res) {
                var chunks_2 = [];

                    res.on("data", function (chunk) {
                    chunks_2.push(chunk);
                    });

                    res.on ("error", function (e) {
                    //callback (e);
                    });

                    res.on("end", function () {
                    var actionBody = Buffer.concat(chunks_2).toString();
                    var ParsedActionBody = JSON.parse(actionBody);
    
                    console.log(actionBody.toString());
       
                    // Nested Logout DELETE //
                        var options_3 = {
                            "method": "DELETE",
                            "hostname": hostName,
                            "port": "443",
                            "path": "/fmi/rest/api/auth/People",
                            "headers": {
                            "content-type": "application/json",
                            "FM-Data-token": Token,
                            "cache-control": "no-cache"
                          }
                        };
                    
                        var req_3 = http.request(options_3, function (res) {
                         var chunks_3 = [];
                    
                          res.on("data", function (chunk) {
                           chunks_3.push(chunk);
                          });
                    
                          res.on ("error", function (e) {
                              //callback (e);
                          });
                    
                          res.on("end", function () {
                            var LogoutBody = Buffer.concat(chunks_3).toString();
                           var ParsedLogoutBody = JSON.parse(LogoutBody);
                        
                           console.log(LogoutBody.toString());
                        
                            // callback (null, ParsedLogoutBody);
                            // Enable to see logout confirm
                      });
                    });
                    
                    // no write required for Logout
                    req_3.end();
                        
                            const foundCount = 
                                
                                // NEW RECORD CREATION //
                                spokenAction==='add' ? '' :
                                
                                // QUERY //
                                ParsedActionBody.data.length;
                                
                            const speechOutput = 
                            
                                // NEW RECORD CREATION //
                                spokenAction==='add' ? 'New ' + spokenTable + ' record created' :
                                
                                // PEOPLE BIRTHDAY QUERY //
                                field==='birthday' ? 'There are ' + foundCount + ' ' + spokenTable + ' with birthdays on ' + content : 
                                
                                // APPOINTMENT QUERY //
                                table==='appointments' ? 'You have ' + foundCount + ' ' + spokenTable + ' on ' + content :
                                
                                // PEOPLE NAME QUERY //
                                field==='first' ? 'There are ' + foundCount + ' ' + spokenTable + ' with the ' + spokenField + ' ' + content :
                                field==='last' ? 'There are ' + foundCount + ' ' + spokenTable + ' with the ' + spokenField + ' ' + content :
                                
                                // PEOPLE ADDRESS QUERY //
                                'There are ' + foundCount + ' ' + spokenTable + ' who live in ' + content;
                            
                        
                            thisIntent.response.cardRenderer(SKILL_NAME, speechOutput);
                            thisIntent.response.speak(speechOutput);
                            thisIntent.emit(':responseReady');
                        
                            // callback (null, ParsedFindBody);
                            // Enable to see find results
                        
                      });
                    });
                    
                    var actionText = 
                        spokenAction==='add' ? JSON.parse('{"data":{\"'+ field + '\":\"' + content + '\"}}') :
                        spokenAction==='find' ? JSON.parse('{"query":[{\"'+ field + '\":\"' + content + '\"}]}') :
                        JSON.parse('{"query":[{\"'+ field + '\":\"' + content + '\"}]}');
                    var apiCall = JSON.stringify(actionText);
                    console.log(actionText);
                    
                    req_2.write(apiCall);
                    req_2.end();
                        
                        // callback (null, Token);
                        // Enable to see auth token
                        
                      });
                    });
                    
                    req.write(JSON.stringify({ user: accountName, password: accountPassword, layout: table }));
                    req.end();
        
    },
    'AMAZON.HelpIntent': function () {
        const speechOutput = HELP_MESSAGE;
        const reprompt = HELP_REPROMPT;

        this.response.speak(speechOutput).listen(reprompt);
        this.emit(':responseReady');
    },
    'AMAZON.CancelIntent': function () {
        this.response.speak(STOP_MESSAGE);
        this.emit(':responseReady');
    },
    'AMAZON.StopIntent': function () {
        this.response.speak(STOP_MESSAGE);
        this.emit(':responseReady');
    },
};

exports.handler = function (event, context, callback) {
    const alexa = Alexa.handler(event, context, callback);
    alexa.APP_ID = APP_ID;
    alexa.registerHandlers(handlers);
    alexa.execute();
};